package com.alibaba.fastjson.util;

import com.alibaba.fastjson.JSON;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.security.ProtectionDomain;

public class ASMClassLoader extends ClassLoader {

   private static ProtectionDomain DOMAIN = (ProtectionDomain)AccessController.doPrivileged(new PrivilegedAction() {
      public Object run() {
         return ASMClassLoader.class.getProtectionDomain();
      }
   });


   public ASMClassLoader() {
      super(getParentClassLoader());
   }

   public ASMClassLoader(ClassLoader parent) {
      super(parent);
   }

   static ClassLoader getParentClassLoader() {
      ClassLoader contextClassLoader = Thread.currentThread().getContextClassLoader();
      if(contextClassLoader != null) {
         try {
            contextClassLoader.loadClass(JSON.class.getName());
            return contextClassLoader;
         } catch (ClassNotFoundException var2) {
            ;
         }
      }

      return JSON.class.getClassLoader();
   }

   public Class defineClassPublic(String name, byte[] b, int off, int len) throws ClassFormatError {
      Class clazz = this.defineClass(name, b, off, len, DOMAIN);
      return clazz;
   }

   public boolean isExternalClass(Class clazz) {
      ClassLoader classLoader = clazz.getClassLoader();
      if(classLoader == null) {
         return false;
      } else {
         for(Object current = this; current != null; current = ((ClassLoader)current).getParent()) {
            if(current == classLoader) {
               return false;
            }
         }

         return true;
      }
   }

}
